com.google.gwt.editor.ui.client

## Class ValueBoxEditorDecorator<T>

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.google.gwt.user.client.ui.Composite
      - - com.google.gwt.editor.ui.client.ValueBoxEditorDecorator<T>

- Type Parameters:
    `T` - the type of data being edited
  All Implemented Interfaces:
    Editor<T>, HasEditorErrors<T>, IsEditor<ValueBoxEditor<T>>, HasAttachHandlers, HasHandlers, EventListener, HasVisibility, IsRenderable, IsWidget

      public class ValueBoxEditorDecorator<T>
      extends Composite
      implements HasEditorErrors<T>, IsEditor<ValueBoxEditor<T>>

  A simple decorator to display leaf widgets with an error message.

  ### Use in UiBinder Templates

  The decorator may have exactly one ValueBoxBase added though an `<e:valuebox>` child tag.

  For example:

       @UiField
       ValueBoxEditorDecorator<String> name;

       <e:ValueBoxEditorDecorator ui:field='name'>
         <e:valuebox>
           <g:TextBox />
         </e:valuebox>
       </e:ValueBoxEditorDecorator>

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `(package private) static interface` | `ValueBoxEditorDecorator.Binder`

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

    - ### Nested classes/interfaces inherited from interface com.google.gwt.editor.client.Editor

      `Editor.Ignore, Editor.Path`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) SimplePanel` | `contents`
    `(package private) DivElement` | `errorLabel`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ValueBoxEditorDecorator()` Constructs a ValueBoxEditorDecorator.
    `ValueBoxEditorDecorator(ValueBoxBase<T> widget, ValueBoxEditor<T> editor)` Constructs a ValueBoxEditorDecorator using a `ValueBoxBase` widget and a `ValueBoxEditor` editor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ValueBoxEditor<T>` | `asEditor()` Returns the associated `ValueBoxEditor`.
    `void` | `setEditor(ValueBoxEditor<T> editor)` Sets the associated `ValueBoxEditor`.
    `void` | `setValueBox(ValueBoxBase<T> widget)` Set the widget that the EditorPanel will display.
    `void` | `showErrors(java.util.List<EditorError> errors)` The default implementation will display, but not consume, received errors whose `getEditor()` method returns the Editor passed into `setEditor(com.google.gwt.editor.ui.client.adapters.ValueBoxEditor<T>)`.

    - ### Methods inherited from class com.google.gwt.user.client.ui.Composite

      `claimElement, getWidget, initializeClaimedElement, initWidget, isAttached, onAttach, onBrowserEvent, onDetach, render, render, resolvePotentialElement, setWidget`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getHandlerCount, getLayoutData, getParent, isOrWasAttached, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, addStyleName, ensureDebugId, ensureDebugId, ensureDebugId, getAbsoluteLeft, getAbsoluteTop, getElement, getOffsetHeight, getOffsetWidth, getStyleElement, getStyleName, getStyleName, getStylePrimaryName, getStylePrimaryName, getTitle, isVisible, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, setElement, setElement, setHeight, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setTitle, setVisible, setVisible, setWidth, sinkBitlessEvent, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### contents

          @UiField
          SimplePanel contents

    - #### errorLabel

          @UiField
          DivElement errorLabel

  - ### Constructor Detail

    - #### ValueBoxEditorDecorator

          @UiConstructor
          public ValueBoxEditorDecorator()

      Constructs a ValueBoxEditorDecorator.

    - #### ValueBoxEditorDecorator

          public ValueBoxEditorDecorator(ValueBoxBase<T> widget,
                                         ValueBoxEditor<T> editor)

      Constructs a ValueBoxEditorDecorator using a `ValueBoxBase` widget and a `ValueBoxEditor` editor.
      Parameters:
        `widget` - the widget
        `editor` - the editor

  - ### Method Detail

    - #### asEditor

          public ValueBoxEditor<T> asEditor()

      Returns the associated `ValueBoxEditor`.
      Specified by:
        `asEditor` in interface `IsEditor<ValueBoxEditor<T>>`
      Returns:
        a `ValueBoxEditor` instance
      See Also:
        `setEditor(ValueBoxEditor)`

    - #### setEditor

          public void setEditor(ValueBoxEditor<T> editor)

      Sets the associated `ValueBoxEditor`.
      Parameters:
        `editor` - a `ValueBoxEditor` instance
      See Also:
        `asEditor()`

    - #### setValueBox

          @UiChild(limit=1,
                   tagname="valuebox")
          public void setValueBox(ValueBoxBase<T> widget)

      Set the widget that the EditorPanel will display. This method will automatically call `setEditor(com.google.gwt.editor.ui.client.adapters.ValueBoxEditor<T>)`.
      Parameters:
        `widget` - a `ValueBoxBase` widget

    - #### showErrors

          public void showErrors(java.util.List<EditorError> errors)

      The default implementation will display, but not consume, received errors whose `getEditor()` method returns the Editor passed into `setEditor(com.google.gwt.editor.ui.client.adapters.ValueBoxEditor<T>)`.
      Specified by:
        `showErrors` in interface `HasEditorErrors<T>`
      Parameters:
        `errors` - a List of `EditorError` instances